// (c) Copyright 2013 Cloudera, Inc. All rights reserved.

define(["cloudera/impala/ImpalaSearchQuery","cloudera/common/TimeUtil","underscore"],function(e,t,n){describe("ImpalaSearchQuery",function(){var r;beforeEach(function(){r={executingQueriesUrl:"/executingQueries",completedQueriesUrl:"/completedQueries",limit:500}}),it("sets startTime and endTime using getServerNow",function(){spyOn(t,"getServerNow").andReturn(new Date(1e3));var n=new e(r);expect(t.getServerNow).wasCalled(),expect(n.startTime).toEqual(new Date(1e3)),expect(n.endTime).toEqual(new Date(1e3))}),it("maintains isCurrentMode property",function(){var t=new e(r);expect(t.isCurrentMode).toBeTruthy()}),it("offers method to set dates and current mode",function(){var t=new e(r);t.setDates(new Date(1e3),new Date(2e3)),expect(t.startTime).toEqual(new Date(1e3)),expect(t.endTime).toEqual(new Date(2e3)),expect(t.isCurrentMode).toBeTruthy(),t.setDates(new Date(1e3),new Date(2e3),!1),expect(t.isCurrentMode).toBeFalsy()}),it("starts with filters undefined",function(){var t=new e(r);expect(t.filters).toEqual(undefined)}),it("calls onStart and onEnd during execution",function(){r.onStart=jasmine.createSpy("onStart"),r.onEnd=jasmine.createSpy("onEnd");var t=new e(r);jasmine.Ajax.useMock(),t.isCurrentMode=!1,t.execute({success:jasmine.createSpy()}),expect(r.onStart).wasCalled(),expect(r.onEnd).wasNotCalled();var n=mostRecentAjaxRequest();n.response({status:200,responseText:""}),expect(r.onEnd).wasCalled()}),describe("execute",function(){var t,i,s,o,u={status:200,responseText:JSON.stringify({errors:[],warnings:[],queries:[]})},a={status:500,responseText:JSON.stringify({})},f=function(e,t){return n.map(n.range(e,t),function(e){return{index:e}})};beforeEach(function(){jasmine.Ajax.useMock(),clearAjaxRequests(),i={success:jasmine.createSpy("success"),error:jasmine.createSpy("error"),complete:jasmine.createSpy("complete")},t=new e(r),t.execute(i),s=ajaxRequests[0],o=ajaxRequests[1]}),it("sends filters even if blank",function(){expect(t.filters).toEqual(undefined),expect(s.url.indexOf("filters=&")!==-1).toBeTruthy(),expect(o.url.indexOf("filters=&")!==-1).toBeTruthy()}),it("handles inflight queries gracefully",function(){t.execute(i),expect(i.success).wasNotCalled(),expect(i.error).wasNotCalled(),expect(i.complete).wasCalled()}),it("does not make executing queries request if not in current mode",function(){t.abort(),t.isCurrentMode=!1,clearAjaxRequests(),t.execute(i),expect(ajaxRequests.length).toEqual(1);var e=mostRecentAjaxRequest();expect(e.url).toContain(r.completedQueriesUrl),e.response(u),expect(i.success).wasCalled()}),it("does okay if there are no success or complete handlers",function(){t.abort(),clearAjaxRequests(),i={},t.execute(i),s=ajaxRequests[0],o=ajaxRequests[1],s.response(u),o.response(u)}),it("does okay if there is not an error handler",function(){t.abort(),clearAjaxRequests(),i={},t.execute(i),s=ajaxRequests[0],o=ajaxRequests[1],s.response(a),o.response(u)}),it("fires the success handler on both success",function(){s.response(u),o.response(u),expect(i.success).wasCalled(),expect(i.error).wasNotCalled(),expect(i.complete).wasCalled()}),it("fires the error handler on one failure",function(){s.response(a),o.response(u),expect(i.success).wasNotCalled(),expect(i.error).wasCalled(),expect(i.complete).wasCalled();var e=i.error.mostRecentCall.args;expect(e[0].then).toBeDefined(),expect(e[1]).toEqual("error"),e=i.complete.mostRecentCall.args,expect(e[0].then).toBeDefined(),expect(e[1]).toEqual("error")}),it("fires the error handler on other failure",function(){s.response(u),o.response(a),expect(i.success).wasNotCalled(),expect(i.error).wasCalled(),expect(i.complete).wasCalled()}),it("splices executing and completed queries together",function(){s.response({status:200,responseText:JSON.stringify({errors:f(20,25),warnings:f(40,45),queries:f(0,5)})}),o.response({status:200,responseText:JSON.stringify({errors:f(25,30),warnings:f(45,50),queries:f(5,10)})}),expect(i.success).wasCalled();var e=i.success.argsForCall[0][0];expect(e).toBeDefined(),expect(e.queries).toBeDefined(),expect(e.errors).toBeDefined(),expect(e.warnings).toBeDefined();var t=e.queries;expect(t.length).toEqual(10),n.each(t,function(e,t){expect(e.index).toEqual(t)});var r=e.errors;expect(r.length).toEqual(10),n.each(r,function(e,t){expect(e.index).toEqual(t+20)});var u=e.warnings;expect(u.length).toEqual(10),n.each(u,function(e,t){expect(e.index).toEqual(t+40)});var a=i.complete.mostRecentCall.args;expect(a[0].queries).toBeDefined(),expect(a[0].errors).toBeDefined(),expect(a[0].warnings).toBeDefined(),expect(a[1]).toEqual("success")})})})})